%% import data first
close all
G14 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G14.xlsx');             %                     (1)                                                          
% G16 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G16.xlsx');
% G18 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G18.xlsx');
% G20 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G20.xlsx');
% G24 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G24.xlsx');


DATA = G14;                                                                        %                    (2)
[row,col]=size(DATA);

T = 2e-5;% should be 2e-5; Hence all the frequency will be divided by 2
Fs = 1/T;
L = row;                             % Length of signal
t = (0:L-1)*T;                        % Time vector
NFFT = 2^(nextpow2(L));    % Next power of 2 from length of y           
Empty_Y = zeros(32768,col);
f = Fs/2*linspace(0,1,NFFT/2+1);
Cutoff = 2000;
for i = 1:col
    data = DATA(:,i);
    
  
%     % Plot signals
%     figure
%     plot(t,data,'k')
%     title('Signal')
%     xlabel('time (seconds)')
%     % saveas(gcf,['Signal_10psi',num2str(i),'.jpg'])

%    data = smooth(data,100,'moving');
%      data = smoothdata(data,'gaussian',10);
%        % Plot signals
%     figure
%     plot(t,data_smooth,'k')
%     title('Signal')
%     xlabel('time (seconds)')
%     % saveas(gcf,['Signal_10psi',num2str(i),'.jpg'])  
%       
      
    Y = fft(data,NFFT)/L;
    Empty_Y(:,i) = Y;         %                                            (1)
    % Y(1) = Y(1)/2;           % the first data is for DC component


    % % Plot single-sided amplitude spectrum.
    % figure
    % plot(f,(2*abs(Y(1:NFFT/2+1))))            %                                         (2)
    % title('Single-Sided Amplitude Spectrum of y(t)')
    % xlabel('Frequency (Hz)')
    % ylabel('E')


    Interest =(2*abs(Y(1:NFFT/2+1)));

%     figure
%     plot(f(10:Cutoff),Interest(10:Cutoff),'k')            %                               (3)
%     % title('Single-Sided Amplitude Spectrum of y(t)')
%     title('Fourior Transform')
%     xlabel('Frequency (Hz)')
%     ylabel('E')
%     % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])

%     frequency = f(10:Cutoff);
%     E = Interest(10:Cutoff);
%     kappa = 5/3;P0 = 101000;rho = 1000;c = 1500;
%     sqrt_ = sqrt(3*kappa*P0/rho);
%     a = 1/2/pi./frequency*sqrt_;
%     figure
%     semilogx(a*1000,E,'k')                                                       %                               (4)
%     title('Fourior Transform')
%     xlabel('a [mm]')
%     ylabel('E')
%     % saveas(gcf,['Spectrum_a_10psi',num2str(i),'.jpg'])

end

Total_Y = 2*abs(Empty_Y(10:Cutoff,:));
Total_Y = Total_Y.^2;

frequency = f(10:Cutoff);

Average_1 = sum(Total_Y(:,1:3)')/3;
Average_2 = sum(Total_Y(:,4:6)')/3;
Average_3 = sum(Total_Y(:,7:9)')/3;
Average_4 = sum(Total_Y(:,10:12)')/3;                                                 %                    (3)
Average = [Average_1;Average_2;Average_3;Average_4]; 

psi = [5 10 14 18];                                                                   %                    (4)
[ F,PSI] = meshgrid(frequency,psi);
    
figure; 
waterfall(F,PSI,Average);
xlabel('frequency [Hz]');ylabel('Pressure [psi]');zlabel('Energy'); 
colormap('jet')
xlim([0 2750])
zlim([0 0.05])

Total_Average = sum(Average)/length(psi); 
Total_Average_Nitrogen_G14 = Total_Average;
figure;
plot(frequency,Average_1,'k','linewidth',1);
xlabel('Frequency (Hz)')
ylabel('Energy')
xlim([0 2750])



   
figure;
    plot(frequency,Average_1,'k')            
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('5 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
       
    
figure;
    plot(frequency,Average_2,'k')          
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('10 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
figure;
    plot(frequency,Average_3,'k')           
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('14 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
figure;
    plot(frequency,Average_4,'k')                                            %                    (5)
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('18 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    xlim([0 2750])
    
    figure;                                                                  %                    (6)
    subplot(411);plot(frequency,Average_1,'k');ylabel('Energy');axis([0 2750 0 0.02])
    subplot(412);plot(frequency,Average_2,'k');ylabel('Energy');axis([0 2750 0 0.02])
    subplot(413);plot(frequency,Average_3,'k');ylabel('Energy');axis([0 2750 0 0.02])
    subplot(414);plot(frequency,Average_4,'k');xlabel('Frequency (Hz)');ylabel('Energy');axis([0 2750 0 0.02])
    
%% Normalized by maximum
        figure;                                                                  %                    (6)
    subplot(411);plot(frequency,Average_1./max(Average_1),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(412);plot(frequency,Average_2./max(Average_2),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(413);plot(frequency,Average_3./max(Average_3),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(414);plot(frequency,Average_4./max(Average_4),'k');xlabel('Frequency (Hz)');ylabel('Energy');axis([0 2750 0 1]);grid on;
    
    
    

kappa = 1.404;P0 = 101000;rho = 1000;c = 1500; %kappa = 1.309 %for methane
sqrt_ = sqrt(3*kappa*P0/rho);
const =1/2/pi *sqrt_
a = const./frequency;
xtick_ = const./[500:500:2500]*1000

A0 = 1e-8;
r = 1.15;
pressure = A0*(sqrt_./a).^2*rho.*a./sqrt((1+(sqrt_./a).^2*r^2/c^2));
E0 = pressure.^2;    


figure;                                                                  %                    (6)
a1=axes;
plot(frequency,Average_1./max(Average_1),'k');
set(a1,'position',[.1,.15,.8,.7],'box','off')
xlabel('frequency [Hz]');
xlim([1 2750])
a2=axes;
set(a2,'position',get(a1,'position'),'ylim',get(a1,'ylim'),'xlim',get(a1,'xlim'),'color','none','ytick',[],'xaxislocation','top')
xlabel('radius [mm]');
% Change the top xticks to 6.5653    3.2827    2.1884    1.6413    1.3131
% for Nitrogen gas

% flowrate for G14: 5 10 14 18 psi --> 2.112115 3.638615 4.859815 6.081
fr = [2.2 3.638615 4.859815 6.081]*1e-3/60;time = 0.6;
for i = 1:length(fr)
    
Eff_n =Average(i,:)./E0;
Eff_V = sum(4/3*pi*a.^3.*Eff_n)*abs(4/3*pi*(a(2))^3-4/3*pi*(a(1))^3); 
V = fr(i)*time;
factor = V/Eff_V;

number = 25/0.6*factor*Eff_n;
index0 = find(a<0.001);number0 = number(index0);N0 = sum(number0);
index1 = find(a>=0.001 & a<0.002);number1= number(index1);N1 = sum(number1);
index2 = find(a>=0.002 & a<0.003);number2= number(index2);N2 = sum(number2);
index3 = find(a>=0.003 & a<0.004);number3= number(index3);N3 = sum(number3);
index4 = find(a>=0.004 & a<0.005);number4= number(index4);N4 = sum(number4);
index5 = find(a>=0.005 & a<0.006);number5= number(index5);N5 = sum(number5);
index6 = find(a>=0.006 & a<0.007);number6= number(index6);N6 = sum(number6);
index7 = find(a>=0.007 & a<0.008);number7= number(index7);N7 = sum(number7);
index8 = find(a>=0.008 & a<0.009);number8= number(index8);N8 = sum(number8);
index9 = find(a>=0.009 & a<0.01 );number9= number(index9);N9 = sum(number9);
index10 = find(a>=0.01);number10= number(index10);N10 = sum(number10);
New_a = [0:0.001:0.01]+0.0005;N = [N0 N1 N2 N3 N4 N5 N6 N7 N8 N9 N10];
figure;bar(New_a*1000,N,'FaceColor',[0 1 1],'BarWidth',1);xlabel('Radius [mm]');ylabel('Number');
end

