%% import data first
close all
% G14 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G14.xlsx');             %                     (1)                                                          
% G16 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G16.xlsx');
G18 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G18.xlsx');
% G20 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G20.xlsx');
% G24 = xlsread('C:\Users\fan_x\Desktop\bubble\Data\Nitrogen\G24.xlsx');


DATA = G18;                                                                        %                    (2)
[row,col]=size(DATA);

T = 2e-5;
Fs = 1/T;
L = row;                             % Length of signal
t = (0:L-1)*T;                        % Time vector
NFFT = 2^(nextpow2(L));    % Next power of 2 from length of y           
Empty_Y = zeros(32768,col);
f = Fs/2*linspace(0,1,NFFT/2+1);
Cutoff = 2000;
for i = 1:col
    data = DATA(:,i);
    
  
%     % Plot signals
%     figure
%     plot(t,data,'k')
%     title('Signal')
%     xlabel('time (seconds)')
%     % saveas(gcf,['Signal_10psi',num2str(i),'.jpg'])

%    data = smooth(data,100,'moving');
%      data = smoothdata(data,'gaussian',10);
%        % Plot signals
%     figure
%     plot(t,data_smooth,'k')
%     title('Signal')
%     xlabel('time (seconds)')
%     % saveas(gcf,['Signal_10psi',num2str(i),'.jpg'])  
%       
      
    Y = fft(data,NFFT)/L;
    Empty_Y(:,i) = Y;         %                                            (1)
    % Y(1) = Y(1)/2;           % the first data is for DC component


    % % Plot single-sided amplitude spectrum.
    % figure
    % plot(f,(2*abs(Y(1:NFFT/2+1))))            %                                         (2)
    % title('Single-Sided Amplitude Spectrum of y(t)')
    % xlabel('Frequency (Hz)')
    % ylabel('E')


    Interest =(2*abs(Y(1:NFFT/2+1)));

%     figure
%     plot(f(10:Cutoff),Interest(10:Cutoff),'k')            %                               (3)
%     % title('Single-Sided Amplitude Spectrum of y(t)')
%     title('Fourior Transform')
%     xlabel('Frequency (Hz)')
%     ylabel('E')
%     % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])

%     frequency = f(10:Cutoff);
%     E = Interest(10:Cutoff);
%     kappa = 5/3;P0 = 101000;rho = 1000;c = 1500;
%     sqrt_ = sqrt(3*kappa*P0/rho);
%     a = 1/2/pi./frequency*sqrt_;
%     figure
%     semilogx(a*1000,E,'k')                                                       %                               (4)
%     title('Fourior Transform')
%     xlabel('a [mm]')
%     ylabel('E')
%     % saveas(gcf,['Spectrum_a_10psi',num2str(i),'.jpg'])

end

Total_Y = 2*abs(Empty_Y(10:Cutoff,:));
Total_Y = Total_Y.^2;
frequency = f(10:Cutoff);

Average_1 = sum(Total_Y(:,1:3)')/3;
Average_2 = sum(Total_Y(:,4:6)')/3;
Average_3 = sum(Total_Y(:,7:9)')/3;
Average_4 = sum(Total_Y(:,10:12)')/3;                                                 %                    (3)
Average_5 = sum(Total_Y(:,13:15)')/3;
Average_6 = sum(Total_Y(:,16:18)')/3;

Average = [Average_1;Average_2;Average_3;Average_4;Average_5;Average_6]; 

psi = [5 10 14 18 22 26];                                                                   %                    (4)
[ F,PSI] = meshgrid(frequency,psi);
    
figure; 
waterfall(F,PSI,Average);
xlabel('frequency [Hz]');ylabel('Pressure [psi]');zlabel('Energy'); 
colormap('jet')
xlim([0 2750])
zlim([0 0.05])

Total_Average = sum(Average)/length(psi);   
Total_Average_Nitrogen_G18 = Total_Average;
figure;
plot(frequency,Average_1,'k','linewidth',1);
xlabel('Frequency (Hz)')
ylabel('Energy')
xlim([0 2750])



   
figure;
    plot(frequency,Average_1,'k')            
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('5 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
       
    
figure;
    plot(frequency,Average_2,'k')          
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('10 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
figure;
    plot(frequency,Average_3,'k')           
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('14 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
figure;
    plot(frequency,Average_4,'k')                                            %                    (5)
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('18 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    xlim([0 2750])
    
figure;
    plot(frequency,Average_5,'k')           
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('22 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
figure;
    plot(frequency,Average_6,'k')           
    % title('Single-Sided Amplitude Spectrum of y(t)')
    title('26 psi')
    xlabel('Frequency (Hz)')
    ylabel('Energy')
    xlim([0 2750])
    % saveas(gcf,['Spectrum_10psi',num2str(i),'.jpg'])
    
    figure;                                                                  %                    (6)
    subplot(611);plot(frequency,Average_1,'k');ylabel('Energy');axis([0 2750 0 0.04])
    subplot(612);plot(frequency,Average_2,'k');ylabel('Energy');axis([0 2750 0 0.04])
    subplot(613);plot(frequency,Average_3,'k');ylabel('Energy');axis([0 2750 0 0.04])
    subplot(614);plot(frequency,Average_4,'k');ylabel('Energy');axis([0 2750 0 0.04])
    subplot(615);plot(frequency,Average_5,'k');ylabel('Energy');axis([0 2750 0 0.04])
    subplot(616);plot(frequency,Average_6,'k');xlabel('Frequency (Hz)');ylabel('Energy');axis([0 2750 0 0.04])

    %% Normalized 
        figure;                                                                  %                    (6)
    subplot(611);plot(frequency,Average_1./max(Average_1),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(612);plot(frequency,Average_2./max(Average_2),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(613);plot(frequency,Average_3./max(Average_3),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(614);plot(frequency,Average_4./max(Average_4),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(615);plot(frequency,Average_5./max(Average_5),'k');ylabel('Energy');axis([0 2750 0 1]);grid on;
    subplot(616);plot(frequency,Average_6./max(Average_6),'k');xlabel('Frequency (Hz)');ylabel('Energy');axis([0 2750 0 1]);grid on;
    
    
    
            

kappa = 1.404;P0 = 101000;rho = 1000;c = 1500; %kappa = 1.309 %for methane
sqrt_ = sqrt(3*kappa*P0/rho);
const =1/2/pi *sqrt_
a = const./frequency;
xtick_ = const./[500:500:2500]*1000

A0 = 1e-8;
% A0 = 1e-5*a;
r = 1.15; %% got from the experiment 1.15 m.
pressure = A0.*(sqrt_./a).^2*rho.*a./sqrt((1+(sqrt_./a).^2*r^2/c^2));
E0 = pressure.^2;    

psi = [5 10 14 18 22 26 30];
G18_fr = [1.622655 3.323155 4.683555 6.043955 7.404355 8.764755 nan ];                    %
G18_jv = [48.82550154 99.99335014 140.927629 181.8619079 222.7961868 263.7304656 nan];    %
fr = G18_fr*1e-3/60;time = 0.6;                                                           %
for i = 1:length(fr)
    
    
% A0 = G18_jv(i);
% r = 1.15; %% got from the experiment 1.15 m.
% pressure = A0.*(sqrt_./a).^2*rho.*a./sqrt((1+(sqrt_./a).^2*r^2/c^2));
% E0 = pressure.^2;      

Eff_n =Average(i,:)./E0;
Volume_array = 4/3*pi*a.^3;
Eff_n_new = (Eff_n(1:end-1)+Eff_n(2:end))/2;
Volume_array_new = abs(Volume_array(2:end)-Volume_array(1:end-1));
Eff_V = sum(Eff_n_new.*Volume_array_new);
% Eff_V = sum(4/3*pi*a.^3.*Eff_n)*abs(4/3*pi*(a(2))^3-4/3*pi*(a(1))^3); 
V = fr(i)*time;
factor = V/Eff_V;

number = 25/0.6*factor*Eff_n;
index0 = find(a<0.001);number0 = number(index0);N0 = sum(number0);
index1 = find(a>=0.001 & a<0.002);number1= number(index1);N1 = sum(number1);
index2 = find(a>=0.002 & a<0.003);number2= number(index2);N2 = sum(number2);
index3 = find(a>=0.003 & a<0.004);number3= number(index3);N3 = sum(number3);
index4 = find(a>=0.004 & a<0.005);number4= number(index4);N4 = sum(number4);
index5 = find(a>=0.005 & a<0.006);number5= number(index5);N5 = sum(number5);
index6 = find(a>=0.006 & a<0.007);number6= number(index6);N6 = sum(number6);
index7 = find(a>=0.007 & a<0.008);number7= number(index7);N7 = sum(number7);
index8 = find(a>=0.008 & a<0.009);number8= number(index8);N8 = sum(number8);
index9 = find(a>=0.009 & a<0.01 );number9= number(index9);N9 = sum(number9);
index10 = find(a>=0.01);number10= number(index10);N10 = sum(number10);
New_a = [0:0.001:0.01]+0.0005;N = [N0 N1 N2 N3 N4 N5 N6 N7 N8 N9 N10];
% figure;bar(New_a*1000,N,'FaceColor',[0 1 1],'BarWidth',1);xlabel('Radius [mm]');ylabel('Number');
N_T = sum(N);N = N/N_T*100;
figure;bar(New_a*1000,N,'FaceColor',[0 1 1],'BarWidth',1);xlabel('Radius [mm]');ylabel('Number Percentage (%)');
text(7,max(N(:))*0.9,'Nitrogen--G18')%
text(7,max(N(:))*0.85,['Pressure: ',num2str(psi(i)),' psi'])
text(7,max(N(:))*0.8,['Flowrate: ',num2str(G18_fr(i)),' L/min'])%
text(7,max(N(:))*0.75,['Jet velocity: ',num2str(G18_jv(i)),' m/s'])%
saveas(gcf,['Nitrogen_G18_',num2str(psi(i)),' psi.jpg'])
end
