%% Pre-rquirement: None
%However, Fs=10KHz, N=2^16, RX coordinate and number, Water Tank Dimension 
% must keep same through step0-3.

%% Function:
%Generate Green Function Dictionary for Water Tank Grid 10x10x10 for three
%different models.

%% ---------------------------Add all functions path-------------------------
path1 = 'C:\Users\yx101\Desktop'; %path that includes Data repository
%path that includes Code for all functions
path2 = '\Data repository\3-programs and algorithms\Code\Code for all functions';
addpath([path1,path2,'\alg_Green_Function']);
%% ------------------------------Main---------------------------------
Fs = 10^4;% Fs=10KHz, RX signals sample frequency, same as step1 Fsd
N = 2^16;% number of FFT, fixed, same as positiveFFT_fixN
a=0:1:(ceil(N/2)-1);
SInput_freqR=Fs/N.*a;
f = SInput_freqR;
%------------------coordinate of scattered hydorphones---------------------
CH_Cdnate =[49,30,121;    26,97.5,74;    52,165,162;...
            131,158,85.5; 191,111,136.5; 164.5,44,135;...
            94,125,83.5].*0.01; %unit:m, 7 RX sensors
numSensorScatter = 7;%Number of sensors = 7
% -------------------------Water Tank Dimension----------------------------
 L = [2.1336  2.1336  1.6788]; 
 h = 0.0254;                % wall thickness [m]
 number_of_modes = 15;      % number of modes
%---------Source coordinate grid,[x,y,z] have 10 points respectively-------
% Totally, 10*10*10=1000 possibble coordinates choices
Source_Coord(1,1:10) = L(1)/20:L(1)/10:(L(1)-L(1)/20);
Source_Coord(2,1:10) = L(2)/20:L(2)/10:(L(2)-L(2)/20);
Source_Coord(3,1:10) = L(3)/20:L(3)/10:(L(3)-L(3)/20);
%----------Choose intrested frequency range for Green Function-------------
w1 = 600;%unit:Hz  Same as Step2
w2 = 2e3;%unit:Hz  Same as Step2
%------------Calculate corresponding frequency index-----------------------
frq_interval = SInput_freqR(2);
fre_index1 = round(w1/frq_interval+1);
fre_index2 = round(w2/frq_interval+1);
%--------------------Water Tank Grids (10x10x10)---------------------------
GridD = 10;
DCL_Dict = cell(numSensorScatter,GridD,GridD,GridD);
MIX_Dict = cell(numSensorScatter,GridD,GridD,GridD);
FRF_Dict = cell(numSensorScatter,GridD,GridD,GridD);
for m=1:numSensorScatter
    rm = CH_Cdnate(m,:);     % Scattered hydrophone position [x y z] [m]
    for i=1:GridD
        for j=1:GridD
            for k=1:GridD
                r0 = [Source_Coord(1,i),Source_Coord(2,j),Source_Coord(3,k)];% source
                %M1: Call real Dirchlet function
                DCLm = M1_Tank_Dirchlet_funcion(L,r0,rm,h,number_of_modes,2*pi*f);
                DCL_Dict{m,i,j,k} = DCLm;
                %Proposed: Call Mix (Dirchlet and FRF) function
                MIXm = Proposed_Tank_MIX_function(L,r0,rm,h,number_of_modes,2*pi*f);
                MIX_Dict{m,i,j,k} = MIXm;
                %M2: Call FRF function
                FRFm = small_tank_FRF_function(L,r0,rm,h,number_of_modes,2*pi*f);
                FRF_Dict{m,i,j,k} = FRFm;
            end % for k
        end % for j
    end % for i
       
end % for m

%Green Function Dictionary 10x10x10
save('Dic_DCL.mat','DCL_Dict');
save('Dic_RFR.mat','FRF_Dict');
save('Dic_MIX.mat','MIX_Dict');
