%% Pre-rquirement: 
% First run: Step1_Tank_Source_Receiver_Fs_Reader_CH1toCH7.m to generate
% .mat file. Then, run this file 

%%  Function: 
% 1. Check origianl receiver signals
% 2. Choose interesting RX signals range to shortcuted signals
% 3. RX signals: time domain to frequency domain
% Input: .mat file
%    CH:CH1-CH7 received signal
%    Fs: Sample frequency
%    Source: source signal
% Output:
%    CHFSInput_FFT{i}
%    CHFSInput_freqR{i}
%    SInput_freqR

%EX: 
%  input: Tank-20-07-29-08-06-36-S7-bubble continous-20 kHz.mat
%  output: 

%Author: XY
clear all;close all;clc;format long;
%% -----------------Important Input Parameter ------------------------
% Input: .mat file which inlcude CH1-CH7 data,Fs,source data
Hydrophone_data = 'Tank-20-07-29-08-06-36-S7-bubble continous-20 kHz';%input: .mat name
%load CH [CH1-CH7] data,Fs,source data
load([Hydrophone_data,'.mat']);
numSensorScatter = 7;%scatter receiver hydrophone number
%---------------------------Add all functions path-------------------------
path1 = 'C:\Users\yx101\Desktop'; %path that includes Data repository
%path that includes Code for all functions
path2 = '\Data repository\3-programs and algorithms\Code\Code for all functions';
addpath([path1,path2,'\alg_preconditioning']);
addpath([path1,path2,'\alg_signal_feature']);
addpath([path1,path2,'\alg_Green_Function\Green_Function Library Grid10']);
addpath([path1,path2,'\alg_Green_Function']);
addpath([path1,path2,'\alg_plot_DF']);
printf=0;%if print the figure or not
%% ---------------------- Downsample RX data--------------------------
%SpectraRation localization method only need Fs=10KHz
dn = 2; %keeping the first sample and then every nth sample after the first
CHd = downsample(CH,dn);%down sample CH
Sourced = downsample(Source,dn);%down sample Source
Fsd = Fs/dn;%After processing,the sample frequency is Fsd
tivd = 1/Fsd;
%---------------%choosing interesting recevied signals'segment-------------
L = length(CHd);
bg =2e3;%start: the bg-th.sample= bg.time*Fs +1;
ed =4.3e4;%end 12040: the ed-th sample, ed = ed.time*Fs +1;
% Observe period [bg,ed] in samples; [(bg-1)*tiv,(ed-1)*tiv] in second
Inter=num2str(bg,ed);
Interval_matrix=[{'Interval(Samples)'};{Inter}];
Lu=ed-bg+1; % The true sample number of each hydrophone channel
CHs=CHd(bg:ed,:);%shortcut the scatter hydrophones received signals
Sources=Sourced(bg:ed,:);%shortcut the source signal
%------shortcut duration, t=((bg-1)*tiv):tiv:((Lu-1)/Fs+(bg-1)*tiv);-------
t=((bg-1)*tivd):tivd:((ed-1)*tivd); 
ts=bg:1:ed;
% for index
T=cell(2,length(ts)+1);T(:,1)={'Time';'Samples'};T(1,2:end)=num2cell(t);
T(2,2:end)=num2cell(ts);
ITV = ['Interval[',num2str(bg),',',num2str(ed),']'];
%% Plot original signal infor [Time-Domain][frequency-Domain][spectrogram]
if (0)
%-------------------------Plot Source Signal-------------------------------
figure('Name','Source','NumberTitle','off');
set(gcf, 'Position', get(0, 'Screensize'));
subplot(2,1,1);
%Plot source signal - time domain
plot(ts,Sources,'r');
legend('Source');xlabel( 'Time [Samples]' ); ylabel( 'Amplitude' );

[YfreqDomain,freqRange] = positiveFFT(Sources,Fsd);
subplot(2,1,2);
%Plot source signal - frequency domain
plot(freqRange/1000,abs(YfreqDomain),'r','LineWidth',1);
xlabel( 'Frequency[KHz]' ); ylabel('Amplitude'); grid on;
legend('Source-');%xlim([0 10]);
if printf==1 print(gcf,['Source',ITV],'-dpng','-r512'); end

%plot source - frequency-time figure
figure; 
pspectrum(Sources,Fsd,'spectrogram','TimeResolution',0.1, ...
    'OverlapPercent',99,'Leakage',0.85);
%------------------------Plot CH1-CH7 received signals---------------------
figure('Name','CH1 to CH7','NumberTitle','off');
set(gcf, 'Position', get(0, 'Screensize'));
%plot CH1-CH7 received signals - time domain
for j=1:numSensorScatter 
    subplot(numSensorScatter,1,j);
    plot(ts,CHs(:,j));
    legend(['CH',num2str(j)]);grid on;
    xlabel( 'Time [Samples]' ); ylabel( 'Amplitude' );
end
if printf==1 print(gcf,['CH1_CH7_TimeDomain',ITV],'-dpng','-r512'); end

figure('Name','CH1 to CH7','NumberTitle','off');
set(gcf, 'Position', get(0, 'Screensize'));
%plot CH1-CH7 received signals - frequency domain
for i=1:numSensorScatter 
    [YfreqDomain,freqRange] = positiveFFT(CHs(:,i),Fsd);
    subplot(numSensorScatter,1,i);
    plot(freqRange/1000,abs(YfreqDomain));
    xlabel( 'Frequency[KHz]' ); ylabel('Amplitude'); grid on;
    legend(['CH',num2str(i)]);%xlim([0 10]);
end
if printf==1 print(gcf,['CH1_CH7_FreqDomain',ITV],'-dpng','-r512'); end

for i=1:numSensorScatter
    %plot CH1-CH7 received signals- frequency-time figure
    figure; 
    pspectrum(CHs(:,i),Fsd,'spectrogram','TimeResolution',0.1, ...
    'OverlapPercent',99,'Leakage',0.85)
    title(['CH',num2str(i)]);
end
end

%% --------------------Preconditioning Processing---------------------
%input: CHs
%output:out1
%% Preconditioning_Config
precond.Band_Pass=1; precond.Teager_kaiser=0; precond.Remove_Mean=1;
precond.Time_Gian=0; precond.Amplitude_norml=0; precond.Plot=1;
precond_value = struct2cell(precond);
precond_head = fieldnames(precond);
precond_matrix = [precond_head';precond_value'];
%% -------------------------Preconditioning --------------------------
input1 = CHs; %All scatter data CH1-CH7
output1 = input1; %output2 = input2; 
 
if(precond.Band_Pass) % Apply band-pass filter
  w1 = 300; w2 = 2e3; %pass and stop band according signal type
  [output1,delay1] = filter_passband_e1(w1,w2,Fsd,output1);  
  %e2:  fps = [w1-1000, w1-500, w2+500, w2+1000];aps = [0 1 0];
  %e1:  fps = [w1-100, w1-50, w2+50, w2+100];aps = [0 1 0];  
end
if(precond.Teager_kaiser) % Apply Teager_kaiser filter
  output1 = teager_kaiser_e2(output1); %new band-pass filter
end
if(precond.Remove_Mean) % Apply remove_mean
  output1 = remove_mean_e2(output1);
end
if(precond.Time_Gian) % Apply time_gian!!!!!(Wrong since doesnt revised)
    time_gain_params = struct('alpha',0.9,'r',1);
    output1 = time_gain(output1, time_gain_params);
end
if(precond.Amplitude_norml) % Apply amplitude normalization
    time_gain_params = struct('alpha',0.9,'r',1);
    output1 = normalize_amplitude_e2(output1);
end
% output have several zeros after filter, remove the zeros
% out1 = output1(1:(end-delay1),:);
out1 = output1;
if(precond.Plot) % Plot Preconditioned signal
%-------------------------Source Signal [TX]-------------------------------
  figure('Name','Source','NumberTitle','off');
  set(gcf, 'Position', get(0, 'Screensize'));
  subplot(2,1,1);
  %Plot source signal - time domain
  plot(ts,Sources,'r'); 
  legend('Source');xlabel( 'Time [Samples]' ); ylabel( 'Amplitude' );

  %time to frequency domain with fix number FFT.
  [YfreqDomain,freqRange] = positiveFFT_fixN(Sources,Fsd);
  SInput_FFT = YfreqDomain;
  SInput_freqR= freqRange;
  subplot(2,1,2);
  plot(freqRange/1000,abs(YfreqDomain),'r','LineWidth',1);
  xlabel( 'Frequency[KHz]' ); ylabel('Amplitude'); grid on;
  legend('Source-');%xlim([0 10]);
        
  if printf==1 print(gcf,['Source',ITV],'-dpng','-r512'); end
%---------------------------CH1-CH7 Signal [RX]----------------------------
    figure('Name','Step2=After Procondtioning signal','NumberTitle','off');
    set(gcf, 'Position', get(0, 'Screensize'));
   for j=1:numSensorScatter %plot CH1-CH7
      subplot(numSensorScatter,1,j); hold on;
      plot(ts,input1(:,j),'r','LineWidth',1);
      plot(ts,out1(:,j),'k','LineWidth',0.7);
      legend(['CH',num2str(j)],['CH',num2str(j),'-Preconditioned']);
      xlabel( 'Time [Samples]' ); ylabel( 'Amplitude' ); hold off;grid on;
    end
    if printf==1 print(gcf,['CH1_CH8_TimeDomain_Preconditoned',ITV],'-dpng','-r512'); end

   figure('Name','CH1 to CH7','NumberTitle','off');
   set(gcf, 'Position', get(0, 'Screensize'));
   for i=1:numSensorScatter
       [YfreqDomain,freqRange] = positiveFFT_fixN(input1(:,i),Fsd);
       [YfreqDomain1,freqRange1] = positiveFFT_fixN(out1(:,i),Fsd);
       CHFSInput_FFT{i} = YfreqDomain1;
       CHFSInput_freqR{i} = freqRange1;
       subplot(numSensorScatter,1,i); hold on;
       plot(freqRange/1000,abs(YfreqDomain),'r','LineWidth',1);
       plot(freqRange1/1000,abs(YfreqDomain1),'k','LineWidth',0.7);
       xlabel( 'Frequency[KHz]' ); ylabel('Amplitude'); grid on; hold off;
       legend(['CH',num2str(i)],['CH',num2str(i),'-Preconditioned']);%xlim([0 10]);
   end
   if printf==1 print(gcf,['CH1_CH8_FrqDomain_preconditioned',ITV],'-dpng','-r512'); end 
 end
      
%------------------EoF preconditioning-----------------------
%Output: 
%  out1:CH1-CH7 :7 column vectors, after preconditioned
%  input1:CH1-CH7 :7 column vectors, before preconditioned
   %----Following Algorithm will use--------------
%  numSensorScatter = 7;%scatter sensor number
   %----Variables for Green Function,i.e. Channel Response-----
%  CHFSInput_FFT{i} :Scatter RX Spectrum
%      Each cell is a column Spectrum vecotr for a scatter RX
%  CHFSInput_freqR{i} :Scatter RX Spectrum frequency range
%      Each cell is a row spectrum frequency point for a scatter RX
%  SInput_freqR