clear all;close all; clc;
%coordinate of CH1-CH7 receiver hydrophones
S1=[89.75, 66.25, 121];
S2=[177, 74.5, 141.5];
S3=[139.75, 52.5, 145.5];
S4=[136.0, 112.5, 140];

CH1 = [49.75, 29.75,121.25];
CH2 = [26.527, 100.25, 75];
CH3 = [54,171.5,155];
CH4 = [131, 159, 81];
CH5 = [189.25,111, 139.75];
CH6 = [163.25, 45, 121.5];
CH7 = [98.5, 119.5, 130];

evVal=[CH7;CH6;CH2;CH4;CH5;CH3]./100; %S1
%evVal=[CH5;CH6;CH4;CH1;CH3;CH2]./100; %S2
%evVal=[CH6;CH5;CH7;CH4;CH2;CH3]./100; %S3

%shifting the reference sensor to origin and shifting the whole sensor
%locations accordingly,
  x2 = evVal(2,1) - evVal(1,1); % Shift x2 location
  y2 = evVal(2,2) - evVal(1,2); % Shift y2 location
  z2= evVal(2,3) - evVal(1,3); % Shift z2 location
 
  x3 = evVal(3,1) - evVal(1,1); % Shift x3 location
  y3 = evVal(3,2) - evVal(1,2); % Shift y3 location
  z3= evVal(3,3) - evVal(1,3); % Shift z3 location
  
  x4 = evVal(4,1) - evVal(1,1); % Shift x4 location
  y4 = evVal(4,2) - evVal(1,2); % Shift y4 location
  z4= evVal(4,3) - evVal(1,3); % Shift z4 location
  
  x5 = evVal(5,1) - evVal(1,1); % Shift x4 location
  y5 = evVal(5,2) - evVal(1,2); % Shift y4 location
  z5= evVal(5,3) - evVal(1,3); % Shift z4 location
  
  x6 = evVal(6,1) - evVal(1,1); % Shift x4 location
  y6 = evVal(6,2) - evVal(1,2); % Shift y4 location
  z6= evVal(6,3) - evVal(1,3); % Shift z4 location
  
% Reading from measurements
% %S1
  delT21 =1.69520E-04; % Difference between 2 and 1
  delT31 = 1.72960E-04; % Difference between 3 and 1
  delT41 = 3.31820E-04; % Difference between 4 and 1
  delT51 = 3.93660E-04;% Difference between 5 and 1
  delT61 = 4.23630E-04;% Difference between 6 and 1
  
% %S2
%   delT21 =3.1500E-05; % Difference between 2 and 1
%   delT31 = 4.7510E-04; % Difference between 3 and 1
%   delT41 = 6.5870E-04; % Difference between 4 and 1
%   delT51 = 7.9040E-04;% Difference between 5 and 1
%   delT61 = 8.5850E-04;% Difference between 6 and 1

% %S3
%   delT21 =2.950E-04; % Difference between 2 and 1
%   delT31 = 3.700E-04; % Difference between 3 and 1
%   delT41 = 5.950E-04; % Difference between 4 and 1
%   delT51 = 6.950E-04;% Difference between 5 and 1
%   delT61 = 7.450E-04;% Difference between 6 and 1
  
  c = 1.5*1000; % velocity in meters/sec
  
% Determine the differences in range
  r21 = delT21 * c; % Range difference between nodes 2 and 1
  r31 = delT31 * c ;% Range difference between nodes 3 and 1
  r41 = delT41 * c ;% Range difference between nodes 4 and 1
  r51 = delT51 * c ;% Range difference between nodes 5 and 1
  r61 = delT61 * c ;% Range difference between nodes 6 and 1

  H = [x2 y2 z2; x3 y3 z3; x4 y4 z4; x5 y5 z5;x6 y6 z6]; % Matrix H 
  C = [-r21; -r31; -r41; -r51; -r61]; % Vector C 
  K2sq = x2^2 + y2^2 + z2^2; % K2 Squared 
  K3sq = x3^2 + y3^2 + z3^2; % K3 Squared 
  K4sq = x4^2 + y4^2 + z4^2; % K4 Squared 
  K5sq = x5^2 + y5^2 + z5^2; % K4 Squared 
  K6sq = x6^2 + y6^2 + z6^2; % K4 Squared 

  D = .5.*[K2sq - r21^2; K3sq - r31^2; K4sq - r41^2; K5sq - r51^2; K6sq - r61^2]; % Vector D 
  
  Xint = [H\C, H\D]; % Intermediate values for vector X. X
    % contains the values [xm = xa*r1 + xb; ym = ya*r1 + yb; zm = za*r1 + zb] in the form of
    % [xa xb xc; ya yb yc; ] which is the location of the source when r1 is solved
    
     % The above expression, when substituted back into Say05, eqn 2, which is
  % r1^2 = xm^2 + ym^2, yields a polynomial of power 2. The following line
  % reorganizes Xint above into that polynomial so that the roots can be
  % determined
  p = [(Xint(1,1)^2 + Xint(2,1)^2 + Xint(3,1)^2 - 1), ... % coefficient for r1^2
    (Xint(1,1)*Xint(1,2)*2 + Xint(2,1)*Xint(2,2)*2 + Xint(3,1)*Xint(3,2)*2), ... % coeff for r1^1
    (Xint(1,2)^2 + Xint(2,2)^2 + Xint(3,2)^2)]; % coefficient for r1^0
  root = roots(p); % determine the roots of the polynomial p
  
  % Pick the largest root to be r1
  r1 = max(real(root));
  xm = r1*Xint(1,1) + Xint(1,2); % Calculate the location of xm in the
    % shifted coordinate system
  ym = r1*Xint(2,1) + Xint(2,2); % Calculate the location of xm in the
    % shifted coordinate system
    zm = r1*Xint(3,1) + Xint(3,2); % Calculate the location of xm in the
    % shifted coordinate system
     % shifted coordinate system
  xSource = xm + evVal(1,1); % Shift x coord back to actual location
  ySource = ym + evVal(1,2); % Shift y coord back to actual location
  zSource = zm + evVal(1,3); % Shift z coord back to actual location
  
Coordinate_Estimate = [xSource, ySource, zSource];% Enter the source locations into a vector
Coordinate_True=S1./100;
Coordinate_rmse = rms(Coordinate_True-Coordinate_Estimate);