clear all;close all; clc;
%coordinate of CH1-CH7 receiver hydrophones
S1=[89.75, 66.25, 121];
S2=[177, 74.5, 141.5];
S3=[139.75, 52.5, 145.5];
S4=[136.0, 112.5, 140];

CH1 = [49.75, 29.75,121.25];
CH2 = [26.527, 100.25, 75];
CH3 = [54,171.5,155];
CH4 = [131, 159, 81];
CH5 = [189.25,111, 139.75];
CH6 = [163.25, 45, 121.5];
CH7 = [98.5, 119.5, 130];


%initial value
x0=0.75;
y0=0.55;
z0=0.80;
% y=abs(x0)+abs(y0)+abs(z0);
del=[1;1;1];
% y=abs(del(1,1))+abs(del(2,1))+abs(del(3,1));
% T=0.05;
n=1;
while (abs(del(1,1)) + abs(del(2,1)) + abs(del(3,1))) > 1e-15 && n<=100
  if n==1
    evVal=[CH7;CH6;CH2;CH4;CH5;CH3]./100; %S1
    %evVal=[CH5;CH6;CH4;CH1;CH3;CH2]./100; %S2
    %evVal=[CH6;CH5;CH7;CH4;CH2;CH3]./100; %S3
    
    %x cordinate
    x1=evVal(1,1);
    x2=evVal(2,1);
    x3=evVal(3,1);
    x4=evVal(4,1);
    x5=evVal(5,1);
    x6=evVal(6,1);
    %y cordinate
    y1=evVal(1,2);
    y2=evVal(2,2);
    y3=evVal(3,2);
    y4=evVal(4,2);
    y5=evVal(5,2);
    y6=evVal(6,2);
    %z cordinate
    z1=evVal(1,3);
    z2=evVal(2,3);
    z3=evVal(3,3);
    z4=evVal(4,3);
    z5=evVal(5,3);
    z6=evVal(6,3);

    % Reading from measurements
% %S1
  delT21 =1.69520E-04; % Difference between 2 and 1
  delT31 = 1.72960E-04; % Difference between 3 and 1
  delT41 = 3.31820E-04; % Difference between 4 and 1
  delT51 = 3.93660E-04;% Difference between 5 and 1
  delT61 = 4.23630E-04;% Difference between 6 and 1
  
% %S2
%   delT21 =3.1500E-05; % Difference between 2 and 1
%   delT31 = 4.7510E-04; % Difference between 3 and 1
%   delT41 = 6.5870E-04; % Difference between 4 and 1
%   delT51 = 7.9040E-04;% Difference between 5 and 1
%   delT61 = 8.5850E-04;% Difference between 6 and 1

% %S3
%   delT21 =2.950E-04; % Difference between 2 and 1
%   delT31 = 3.700E-04; % Difference between 3 and 1
%   delT41 = 5.950E-04; % Difference between 4 and 1
%   delT51 = 6.950E-04;% Difference between 5 and 1
%   delT61 = 7.450E-04;% Difference between 6 and 1
   
    c = 1.5*1000; % velocity in meters/sec

    r21=delT21*c; % Range difference between nodes 2 and 1
    r31=delT31*c; % Range difference between nodes 3 and 1
    r41=delT41*c; %Range difference between nodes 4 and 1
    r51=delT51*c; %Range difference between nodes 5 and 1
    r61=delT61*c; %Range difference between nodes 6 and 1

    h=[r21 ,r31, r41, r51,r61]' ;
   end
r10=sqrt((x1-x0)^2+(y1-y0)^2+(z1-z0)^2);% Range difference between nodes 1 and guess node
r20=sqrt((x2-x0)^2+(y2-y0)^2+(z2-z0)^2);% Range difference between nodes 2 and guess node
r30=sqrt((x3-x0)^2+(y3-y0)^2+(z3-z0)^2); %Range difference between nodes 3 and guess node
r40=sqrt((x4-x0)^2+(y4-y0)^2+(z4-z0)^2); %Range difference between nodes 4 and guess node
r50=sqrt((x5-x0)^2+(y5-y0)^2+(z5-z0)^2); %Range difference between nodes 5 and guess node
r60=sqrt((x6-x0)^2+(y6-y0)^2+(z6-z0)^2); %Range difference between nodes  6 and guess node
f=[r20- r10 ,r30-r10, r40-r10, r50-r10 ,r60-r10]';
% f=[r10 ,r20, r30, r40 ,r50 ,r60]'
a11=((x1-x0)/r10-(x2-x0)/r20);
a12=(((y1-y0)/r10)-((y2-y0)/r20));
a13=(((z1-z0)/r10)-((z2-z0)/r20));
a21=(((x1-x0)/r10)-((x3-x0)/r30));
a22=(((y1-y0)/r10)-((y3-y0)/r30));
a23=(((z1-z0)/r10)-((z3-z0)/r30));
a31=(((x1-x0)/r10)-((x4-x0)/r40));
a32=(((y1-y0)/r10)-((y4-y0)/r40));
a33=(((z1-z0)/r10)-((z4-z0)/r40));
a41=(((x1-x0)/r10)-((x5-x0)/r50));
a42=(((y1-y0)/r10)-((y5-y0)/r50));
a43=(((z1-z0)/r10)-((z5-z0)/r50));
a51=(((x1-x0)/r10)-((x6-x0)/r60));
a52=(((y1-y0)/r10)-((y6-y0)/r60));
a53=(((z1-z0)/r10)-((z6-z0)/r60));
% a61=((x6-x0)/r60);
% a62=((y6-y0)/r60);
% a63=((z6-z0)/r60);

A=[a11 a12 a13;a21 a22 a23;a31 a32 a33;a41 a42 a43;a51 a52 a53];
% del=[delx dely delz]';
Q=[1 0 0 0 0; 0 1 0 0 0 ; 0 0 1 0 0 ; 0 0 0 1 0; 0 0 0 0 1];
del= inv(transpose(A)*inv(Q)*A)*transpose(A)*inv(Q)*(h-f);
% del=pinv(A)*(h-f);
if(abs(del(1,1)) + abs(del(2,1)) + abs(del(3,1))) >1e-15

x0= del(1,1)+x0;
y0=del(2,1)+y0;
z0=del(3,1)+z0;
end
n=n+1;

% y=abs(del(1,1))+abs(del(2,1))+abs(del(3,1));
% n=n+1;
% locSource = [x0; y0; z0]
error=[del];
end
Coordinate_Estimate = [x0,y0,z0];% Enter the source locations into a vector
Coordinate_True=S1./100;
Coordinate_rmse = rms(Coordinate_Estimate-Coordinate_True);
