function [output,delayI] = filter_passband_e1(w1,w2,Fs,input)
  % Function: use kaiserord window-based FIR filter
  % pass frequency=w1
  % pass frequency=w2;
  
  %fps = [300 350 2.65e3 2.7e3];
  fps = [w1-100, w1-50, w2+50, w2+100];
  aps = [0 1 0];
  rprs = [0.01 0.01 0.01];

  [n,fo,ao,w] = firpmord(fps,aps,rprs,Fs);
  [b,err]= firpm(n,fo,ao,w);
  
  FInput = filter(b,1,input,[],1);
  
  %figure; grpdelay(b,Lu,Fs);%Lu:the length of signal
  delay = mean(grpdelay(b));
  delayI = round(delay);
  
  % shift filed data to sync with original data
  [cols,rows] = size(FInput);
  Sync_FInput = zeros(cols,rows);
  Sync_FInput(1:end-delayI,:) = FInput(delayI+1:end,:); 
  
  output = Sync_FInput;
end