function y = teager_kaiser_e2(x)

% y = teager_kaiser(x) applies the Teager-Kaiser energy operator to
% input signal x.

% Source from Thierry Dutoit, Ferran Marques, 
%   "Applied Signal Processing-A MATLAB-Based Proof of Concept"
%   Springer:New-York, 2009

[rows,~] = size(x);%multiple column-vectors,
y = x(2:(rows-1),:).^2-x(1:(rows-2),:).*x(3:rows,:);
y = [y(1,:); y; y(rows-2,:)]; % so that lenght(y)=length(x)

end
% TK should'nt be applied as it is only convenient for impulsive signals, and
% minke whales are not, so TK removes them. Not useful in our case.